//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "stdafx.h"
#include "NumEdit.h"
// emulEspaa: added by MoNKi
#include "emule.h"
#include "locale.h"
// end emulEspaa

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CNumEdit

IMPLEMENT_DYNAMIC(CNumEdit, CEdit)
CNumEdit::CNumEdit()
{
}

CNumEdit::~CNumEdit()
{
}

BEGIN_MESSAGE_MAP(CNumEdit, CEdit)
	ON_WM_CHAR()
	ON_MESSAGE(WM_PASTE,OnPaste)
END_MESSAGE_MAP()

// CNumEdit message handlers

void CNumEdit::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) {
	// [TPT] - MoNKi: -i18n support in CNumEdit-
	// Check new Char
	if(nChar ==  VK_BACK || (nChar >= '0' && nChar <= '9')){
		// Foward char
		CEdit::OnChar(nChar, nRepCnt, nFlags);
	}
	else {
		struct lconv *lconvStruct;		
		lconvStruct = localeconv();

		if (CString((char)nChar) == CString(lconvStruct->decimal_point)){
		// Check if those chars have been already used
		CString buffer;
		GetWindowText(buffer);
			if(buffer.Find(lconvStruct->decimal_point) == -1){
			// Foward char
			CEdit::OnChar(nChar, nRepCnt, nFlags);
		}
	}
	}
	// [TPT] - MoNKi: -i18n support in CNumEdit-
}

LONG CNumEdit::OnPaste(UINT wParam, LONG lParam)
{
	// [TPT] - MoNKi: -OnPaste support in CNumEdit-
	// Using code from Tom Archer:
	// http://www.codeproject.com/clipboard/archerclipboard1.asp
	if (OpenClipboard()){
		if (::IsClipboardFormatAvailable(CF_TEXT)
		|| ::IsClipboardFormatAvailable(CF_OEMTEXT)){
			// Retrieve the Clipboard data (specifying that 
			// we want ANSI text (via the CF_TEXT value).
			HANDLE hClipboardData = GetClipboardData(CF_TEXT);

			// Call GlobalLock so that to retrieve a pointer
			// to the data associated with the handle returned
			// from GetClipboardData.
			char *pchData = (char*)GlobalLock(hClipboardData);

			//Checks the string and paste the result
			float fValue = _tstof(pchData);
			CString valueStr,curText;
			int startChar, endChar;

			GetSel(startChar,endChar);
			GetWindowText(curText);
			valueStr.Format("%s%.1f%s",curText.Left(startChar),fValue,curText.Right(curText.GetLength()-endChar));
			fValue = _tstof(valueStr);
			valueStr.Format("%.1f",fValue);
			SetWindowText(valueStr);

			// Unlock the global memory.
			GlobalUnlock(hClipboardData);
		}
		// Finally, when finished I simply close the Clipboard
		// which has the effect of unlocking it so that other
		// applications can examine or modify its contents.
		CloseClipboard();
	}
	// [TPT] - MoNKi: -OnPaste support in CNumEdit-
	return 0L;
}

